/***********      .---.         .-"-.      *******************\
* -------- *     /   ._.       /  ` \     * ---------------- *
* Author's *     \_  (__\      \_v_/     * humus@rogers.com *
*   note   *     //   \\       //   \\     * ICQ #47010716    *
* -------- *    ((     ))     ((     ))    * ---------------- *
*          ****--""---""-------""---""--****                  ********\
* This file is a part of the work done by Humus. You are free to use  *
* the code in any way you like, modified, unmodified or copy'n'pasted *
* into your own work. However, I expect you to respect these points:  *
*  @ If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  @ For use in anything commercial, please request my approval.      *
*  @ Share your work and ideas too as much as you can.                *
\*********************************************************************/

#ifndef _DIRECT3DRENDERERTARGET_H_
#define _DIRECT3DRENDERERTARGET_H_

#include "../RenderTarget.h"
#include <d3d9.h>

class Direct3DRenderTarget : public RenderTarget {
protected:
	LPDIRECT3DDEVICE9 dev;
    LPDIRECT3DSURFACE9 colorSurface[6];
    LPDIRECT3DSURFACE9 depthSurface;
	bool isCubeMap;

public:
	Direct3DRenderTarget(LPDIRECT3DDEVICE9 d3ddevice);

	bool bind();
	bool unbind();
	
	bool create(const int w, const int h, const bool mipmapped, const bool cubemap, RenderPixelFormat rPixelFormat);
	bool destroy();

	bool setCurrent();
	bool unsetCurrent();

	bool isLost();
	bool setRenderFace(const int face);
};

#endif // _DIRECT3DRENDERERTARGET_H_
