/***********      .---.         .-"-.      *******************\
* -------- *     /   ._.       /  ` \     * ---------------- *
* Author's *     \_  (__\      \_v_/     * humus@rogers.com *
*   note   *     //   \\       //   \\     * ICQ #47010716    *
* -------- *    ((     ))     ((     ))    * ---------------- *
*          ****--""---""-------""---""--****                  ********\
* This file is a part of the work done by Humus. You are free to use  *
* the code in any way you like, modified, unmodified or copy'n'pasted *
* into your own work. However, I expect you to respect these points:  *
*  @ If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  @ For use in anything commercial, please request my approval.      *
*  @ Share your work and ideas too as much as you can.                *
\*********************************************************************/

#ifndef _FRAMEWORK_H_
#define _FRAMEWORK_H_

#include "Platform.h"

#if defined(WIN32)

#ifdef USING_DIRECT3D
#include "../Framework/Windows/Direct3DApp.h"
#else
#include "../Framework/Windows/OpenGLApp.h"
#endif

#define DECLARE_MAIN_APP(MainAppClass) MainAppClass mainApp;

#define ALERT(str, str2) MessageBox(NULL, str, str2, MB_OK | MB_ICONERROR)

#elif defined(LINUX)

#include "../Framework/Linux/OpenGLApp.h"

#define DECLARE_MAIN_APP(MainAppClass) MainAppClass _mainApp; OpenGLApp *mainApp = &_mainApp;

#include <stdio.h>
#define ALERT(str, str2) printf("[%s]\n%s\n", (const char *) (str2), (const char *) (str))

#endif

#endif // _FRAMEWORK_H_
