/***********      .---.         .-"-.      *******************\
* -------- *     /   ._.       /  ` \     * ---------------- *
* Author's *     \_  (__\      \_v_/     * humus@rogers.com *
*   note   *     //   \\       //   \\     * ICQ #47010716    *
* -------- *    ((     ))     ((     ))    * ---------------- *
*          ****--""---""-------""---""--****                  ********\
* This file is a part of the work done by Humus. You are free to use  *
* the code in any way you like, modified, unmodified or copy'n'pasted *
* into your own work. However, I expect you to respect these points:  *
*  @ If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  @ For use in anything commercial, please request my approval.      *
*  @ Share your work and ideas too as much as you can.                *
\*********************************************************************/

#ifndef _IMAGE3D_H_
#define _IMAGE3D_H_

class Image3D {
protected:
	unsigned char *pixels;
	int width, height, depth;
	int nChannels;
	int nMipMaps;
	bool ownsMemory;

public:
	Image3D();
	Image3D(const Image3D &img);
	~Image3D();

	void free();
	void clear();

	unsigned char *getImage(int mipMapLevel = 0) const;
	int getNumberOfMipMaps() const;
	int getNumberOfMipMapsFromDimesions() const;
	int getMipMappedSize(int firstMipMapLevel = 0, int nMipMapLevels = 0x7fffffff) const;

	int getWidth (int mipMapLevel = 0) const;
	int getHeight(int mipMapLevel = 0) const;
	int getDepth (int mipMapLevel = 0) const;
	int getChannels() const;

protected:
	void buildMipMap(unsigned char *dest, unsigned char *src, int width, int height, int depth, int channels);
public:
	bool loadFromFile(const char *fileName);
	void loadFromMemory(unsigned char *mem, const int w, const int h, const int d, const int channels, bool ownsmemory, bool mipMapped = false);
	bool createMipMaps();
};

#endif // _IMAGE3D_H_
