/***********      .---.         .-"-.      *******************\
* -------- *     /   ._.       /  ` \     * ---------------- *
* Author's *     \_  (__\      \_v_/     * humus@rogers.com *
*   note   *     //   \\       //   \\     * ICQ #47010716    *
* -------- *    ((     ))     ((     ))    * ---------------- *
*          ****--""---""-------""---""--****                  ********\
* This file is a part of the work done by Humus. You are free to use  *
* the code in any way you like, modified, unmodified or copy'n'pasted *
* into your own work. However, I expect you to respect these points:  *
*  @ If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  @ For use in anything commercial, please request my approval.      *
*  @ Share your work and ideas too as much as you can.                *
\*********************************************************************/

#ifndef _OPENGLRENDERERTARGET_H_
#define _OPENGLRENDERERTARGET_H_


#include "../RenderTarget.h"
#include "glExtensions.h"

class OpenGLRenderTarget : public RenderTarget {
public:
#ifdef LINUX
	OpenGLRenderTarget(GLXContext mCtx, Display *disp, int scr, Window win){
		mainCtx = mCtx;
		display = disp;
		window = win;
		screen = scr;
	}
#endif
protected:
#if defined(WIN32)
	HPBUFFERARB hPBuffer;
	HDC hPdc;
	HGLRC hPrc;
#elif defined(LINUX)
	GLXContext mainCtx;
	GLXPbuffer pBuffer;
	GLXContext ctx;
	Display *display;
	int screen;
	Window window;
#endif
	
public:
	bool bind();
	bool unbind();
	
	bool create(const int w, const int h, const bool mipmapped, const bool cubemap, RenderPixelFormat rPixelFormat);
	bool destroy();

	bool setCurrent();
	bool unsetCurrent();

	bool isLost();
	bool setRenderFace(const int face);
};

#endif // _OPENGLRENDERERTARGET_H_
