/***********      .---.         .-"-.      *******************\
* -------- *     /   ._.       /  ` \     * ---------------- *
* Author's *     \_  (__\      \_v_/     * humus@rogers.com *
*   note   *     //   \\       //   \\     * ICQ #47010716    *
* -------- *    ((     ))     ((     ))    * ---------------- *
*          ****--""---""-------""---""--****                  ********\
* This file is a part of the work done by Humus. You are free to use  *
* the code in any way you like, modified, unmodified or copy'n'pasted *
* into your own work. However, I expect you to respect these points:  *
*  @ If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  @ For use in anything commercial, please request my approval.      *
*  @ Share your work and ideas too as much as you can.                *
\*********************************************************************/

#ifndef _COLLISIONSET_H_
#define _COLLISIONSET_H_

#include "Set.h"
#include "../Math/Plane.h"

struct CollPoly;

class CollisionSet {
private:
	Set <CollPoly *> polys;
	CollPoly *top;
public:
	CollisionSet();
	~CollisionSet();

	void clear();

	void addStaticPolygon(const Vertex *vertices, const int nVertices);
	void finalizeStatics();

	void pushSphere(const Vertex &oldPos, Vertex &currPos, const float radius) const;

	// Calculates the distance the ray from v0 to v1 passes through solid geometry.
	float depth(const Vertex &v0, const Vertex &v1) const;
};



#endif // _COLLISIONSET_H_
