/***********      .---.         .-"-.      *******************\
* -------- *     /   ._.       /  ` \     * ---------------- *
* Author's *     \_  (__\      \_v_/     * humus@rogers.com *
*   note   *     //   \\       //   \\     * ICQ #47010716    *
* -------- *    ((     ))     ((     ))    * ---------------- *
*          ****--""---""-------""---""--****                  ********\
* This file is a part of the work done by Humus. You are free to use  *
* the code in any way you like, modified, unmodified or copy'n'pasted *
* into your own work. However, I expect you to respect these points:  *
*  @ If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  @ For use in anything commercial, please request my approval.      *
*  @ Share your work and ideas too as much as you can.                *
\*********************************************************************/

#ifndef _CONFIG_H_
#define _CONFIG_H_

#include "Set.h"

struct Var {
	char *name;
	int nameLen;
	char *value;
	int valueLen;
};

class Config {
private:
	Set <Var> vars;
public:
	Config();
	~Config();

	void clear();
	bool loadFromFile(const char *fileName);
	bool writeToFile(const char *fileName);

	bool find(const char *name, int *index = NULL);
	bool remove(const char *name);

	bool getBool(const char *name, bool &value);
	bool getInt(const char *name, int &value);
	char *getString(const char *name);

	void setBool(const char *name, bool value);
	void setInt(const char *name, int value);
	void setString(const char *name, char *value);
};


#endif // _CONFIG_H_
