/***********      .---.         .-"-.      *******************\
* -------- *     /   ._.       /  ` \     * ---------------- *
* Author's *     \_  (__\      \_v_/     * humus@rogers.com *
*   note   *     //   \\       //   \\     * ICQ #47010716    *
* -------- *    ((     ))     ((     ))    * ---------------- *
*          ****--""---""-------""---""--****                  ********\
* This file is a part of the work done by Humus. You are free to use  *
* the code in any way you like, modified, unmodified or copy'n'pasted *
* into your own work. However, I expect you to respect these points:  *
*  @ If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  @ For use in anything commercial, please request my approval.      *
*  @ Share your work and ideas too as much as you can.                *
\*********************************************************************/

#ifndef _DEMOLOOPER_H_
#define _DEMOLOOPER_H_

#include "../Util/Set.h"
#include "../Math/Vertex.h"

class LoopNode {
public:
	float x,y,z;
	float Wx, Wy, Wz;

    LoopNode(){}
	LoopNode(const float X, const float Y, const float Z, const float WX, const float WY, const float WZ){
		x = X;
		y = Y;
		z = Z;
		Wx = WX;
		Wy = WY;
		Wz = WZ;
	}
};


// ##############################################################################################################################


class DemoLooper {
private:
	Set <LoopNode> nodes;
	bool clampIndices;
public:
	DemoLooper();
	~DemoLooper();

	void setClampMode(const bool clamp){ clampIndices = clamp; }

    bool loadFromFile(char *fileName);
    bool writeToFile(char *fileName);

	void addNode(const Vertex &pos, const float Wx, const float Wy, const float Wz);
	void removeNode(const int index);
	void removeLastNode();
    void clear();

    int getNumberOfNodes() const { return nodes.getSize(); }

	LoopNode getNode(const float t);
};


#endif // _DEMOLOOPER_H_
