/***********      .---.         .-"-.      *******************\
* -------- *     /   ._.       /  ` \     * ---------------- *
* Author's *     \_  (__\      \_v_/     * humus@rogers.com *
*   note   *     //   \\       //   \\     * ICQ #47010716    *
* -------- *    ((     ))     ((     ))    * ---------------- *
*          ****--""---""-------""---""--****                  ********\
* This file is a part of the work done by Humus. You are free to use  *
* the code in any way you like, modified, unmodified or copy'n'pasted *
* into your own work. However, I expect you to respect these points:  *
*  @ If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  @ For use in anything commercial, please request my approval.      *
*  @ Share your work and ideas too as much as you can.                *
\*********************************************************************/


#ifndef _LIGHT_H_
#define _LIGHT_H_

#include "../Math/Vertex.h"
#include "../Math/Color.h"

class Light {
protected:
	Vertex position;
	float size;
	Color color;

	Vertex coronaDir;
	float coronaSizeFactor;
	float lastVisibleTime;
	float lastHiddenTime;
	bool corona;
	bool doubleSided;
public:
	Light(){}
	Light(const Vertex &pos, const Color &col, const float Size);


    void setPosition(const Vertex &pos){ position = pos; }
    void setColor(const Color &col){ color = col; }
    void setSize(const float Size){ size = Size; }

	const Vertex &getPosition() const {	return position; }
	const Color &getColor() const { return color; }
	const float getSize() const { return size; }
	const bool hasCorona() const { return corona; }

	void setCorona(const Vertex &CoronaDir, const float CoronaSizeFactor, const bool DoubleSided);
	void setLastTime(const bool visible, const float time);

	const float getCoronaSize(const Vertex &pos, const float currTime);
};

#endif // _LIGHT_H_
