/***********      .---.         .-"-.      *******************\
* -------- *     /   ._.       /  ` \     * ---------------- *
* Author's *     \_  (__\      \_v_/     * humus@rogers.com *
*   note   *     //   \\       //   \\     * ICQ #47010716    *
* -------- *    ((     ))     ((     ))    * ---------------- *
*          ****--""---""-------""---""--****                  ********\
* This file is a part of the work done by Humus. You are free to use  *
* the code in any way you like, modified, unmodified or copy'n'pasted *
* into your own work. However, I expect you to respect these points:  *
*  @ If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  @ For use in anything commercial, please request my approval.      *
*  @ Share your work and ideas too as much as you can.                *
\*********************************************************************/

#include "OpenGLPolygon.h"


void OpenGLPolygon::draw(Renderer *renderer){
	if (!(flags & PF_PORTAL)){
		renderer->setTextures(material->textures[0]);
		if (flags & PF_TRANSLUCENT) renderer->setBlending(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	}
	renderer->apply();
	
	glBegin(GL_TRIANGLE_FAN);
	for (unsigned int i = 0; i < nVertices; i++){
		Vertex v = vertices[i] - origin;
		
		glTexCoord2f(v * s * scaleS, v * t * scaleT);
		
		glVertex3fv(vertices[i]);
	}
	glEnd();
}

class Polygon *OpenGLPolygon::create(const int size) const {
	return new OpenGLPolygon(size);
}









class Polygon *openGLPolyCreator(const int size){
	return new OpenGLPolygon(size);
}
