/***********      .---.         .-"-.      *******************\
* -------- *     /   ._.       /  ` \     * ---------------- *
* Author's *     \_  (__\      \_v_/     * humus@rogers.com *
*   note   *     //   \\       //   \\     * ICQ #47010716    *
* -------- *    ((     ))     ((     ))    * ---------------- *
*          ****--""---""-------""---""--****                  ********\
* This file is a part of the work done by Humus. You are free to use  *
* the code in any way you like, modified, unmodified or copy'n'pasted *
* into your own work. However, I expect you to respect these points:  *
*  @ If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  @ For use in anything commercial, please request my approval.      *
*  @ Share your work and ideas too as much as you can.                *
\*********************************************************************/

#ifndef _PROCEDURALTERRAIN_H_
#define _PROCEDURALTERRAIN_H_

#include "../Renderer.h"
#include "../Math/Vertex.h"
#include "OrderedSet.h"
#include "Fifo.h"

typedef float (* ProceduralTerrainFunc)(const float x, const float z);

struct Block;

class ProceduralTerrain {
protected:
	ProceduralTerrainFunc terrainFunc;
	//OrderedSet <Block> blocks;
	Set <Block *> blocks;
	//Fifo <Block> blockQueue;
	unsigned int maxBlocks;
	Set <unsigned int *> indices;
	Set <unsigned int> indexBuffers;
	float blockSize;
	int blockDensity;
	int texRepeat;

	void setBlock(Block *block);
	void freeBlock(const Block *block);

public:
	ProceduralTerrain(ProceduralTerrainFunc terrFunc, float bSize, int bDensity, int blockTexRepeat, int mBlocks);
	~ProceduralTerrain();

	float blockDistance(const int x, const int z, const Vertex &pos);
	int draw(Renderer *renderer, const Vertex &pos, float viewDistance, float lodFactor);

};

#endif // _PROCEDURALTERRAIN_H_
