/***********      .---.         .-"-.      *******************\
* -------- *     /   ._.       /  ` \     * ---------------- *
* Author's *     \_  (__\      \_v_/     * humus@rogers.com *
*   note   *     //   \\       //   \\     * ICQ #47010716    *
* -------- *    ((     ))     ((     ))    * ---------------- *
*          ****--""---""-------""---""--****                  ********\
* This file is a part of the work done by Humus. You are free to use  *
* the code in any way you like, modified, unmodified or copy'n'pasted *
* into your own work. However, I expect you to respect these points:  *
*  @ If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  @ For use in anything commercial, please request my approval.      *
*  @ Share your work and ideas too as much as you can.                *
\*********************************************************************/

#ifndef _BSP_H_
#define _BSP_H_

#include "Polygon.h"

struct BSPNode {
	class Polygon *polygon;

	BSPNode *back;
	BSPNode *front;

	BSPNode();
	~BSPNode();

	void build(Set <class Polygon *> &polys);
	void draw(Renderer *renderer);
};

class BSPTree {
private:
	BSPNode *top;


public:
	BSPTree();
	~BSPTree();

	void build(Set <class Polygon *> &polys);
	void draw(Renderer *renderer);
};


#endif // _BSP_H_
